// ͻ
//       CHAPITRE V : Trucs et astuces pour la programmation de jeux       
// ͹
//  Description/Contenu : # Utilisation de la souris.                      
//                        # Utilisation des effets de palette.             
//                        # Affichage de texte  l'cran en mode graphique 
//                          via des oprateurs logiques.                   
//                        # Utilisation des classes pour l'affichage       
//                          de sprites.                                    
//                        # Utilisation de l'imprimante.                   
//                                                                         
//  Compilateur : Borland Turbo C++ 3.0                                    
//  MODELE DE COMPILATION : LARGE                                          
//  Auteur : Franck Bauquier - Defcon1                                     
//  Questions : defcon1@caramail.com                                       
//              http://defcon1.free.fr                                     
// ͼ
#include <conio.h>
#include <string.h>
#include <stdio.h>
#include <dos.h>
#include <process.h> // exit()

#include "fxpal.h" // Effets de palette
#include "lettre.h" // Routine de texte
#include "mouse.h" // Gestion de la souris
#include "sprite.h" // Gestion des sprites

// Globales
unsigned char * vga = (unsigned char*) (0xA0000000L); //pointeur vido
unsigned char fond[64000]; //Sauvegarde de l'image de fond
unsigned char virtuel[64000]; //Ecarn virtuel
unsigned char nom[20]; //Sauvegarde du nom (20 caractres maximum)
unsigned char path[30]; // Chemin d'accs au fichier  imprimer

unsigned actif=0,i=0;  // "actif" pour l'activit en cours
		       // (0=rien | 1=Imprimer | 2=Aide)
		       // "i" : caractre courant dans path

MouseType curseur;     // Dclaration d'un curseur
Buffer bouton1;        // Dclaration d'un buffer pour les boutons
Buffer fond1;          // Dclaration d'un buffer pour le fond

// Listing des fonctions du programme
// 
void initscreen();
void intro();

int GetChoice();
int affinfos();
int impression();

void Imprimer();
void Quitter();
void Credits();
void Aide();

// ͻ
//  initscreen() - Affiche le premier cran                               
// ͼ
void initscreen()
{
textbackground(0);  // fond en noir
textcolor(15);      // texte en blanc brillant
clrscr();           // on efface toute la fentre active
textbackground(1);  // fond en bleu
insline();          // on insre une ligne
cprintf(" CHAPITRE V - Effets graphiques, priphries et autres...\r\n\n");
gotoxy(80-15,1); // on place le curseur
textcolor(14); // texte en jaune
cprintf("par F.Bauquier"); // on crit du texte
textbackground(0); // fond en noir
textcolor(15); //texte en blanc brillant
window(24,8,60,25);  // Dimension de la nouvelle fentre
cprintf("ͻ\r\n"); //texte
cprintf(" Bienvenue dans le chapitre V \r\n");
cprintf("ͼ\r\n");
cprintf("\nCe programme utilise:\r\n\n");
cprintf("# Une souris.\r\n");
cprintf("# Une imprimante (faculatif).\r\n");
cprintf("# Une carte graphique VGA.\r\n");
cprintf("# Des effets de palette.\r\n");
cprintf("# Les oprateurs logiques.\r\n");
window(1,1,80,25); //nouvelles dimension de fentre
textcolor(6);  // texte en marron
gotoxy(80-53,25); // nouvelle dimension
cprintf("BackSpace: Effacer | Esc: Quitter | Entre: Continuer");
textbackground(0); // fond en noir
textcolor(15);  // texte en blanc brillant
window(20,20,80,24); //nouvelle dimmension de la fantre active
clrscr();  // on efface la fentre active
memset(nom,0,30);  // remplit "nom" de 0 (le vide en clair)
strcpy(nom,"Mr Dupont"); //Donne une valeur par dfaut que l'on effacera
cprintf("\rvotre nom (20 maxi) : %s",nom); //Demande le nom sans le saisir

int clavier=0,i=9,done=0;  // clavier rcupre la touche frappe
			   // done est mis  1 pour sortir de la boule
			   //			et ainsi du programme
			   // i est l'index utilise pour "nom"
tiptop:;                   // Repre
clavier=done=0;            // "clavier" et "done" mis  zro
while(!done)               // tant que "done" est  zro
{
clavier=getch();           // on rcupre la touche frappe par l'utilisateur
switch(clavier){           // on trie
case 8:  if(i>0){          // si BackSpace est frapp et si on n'est pas au
	 nom[--i]=0;       // dbut de "nom", alors le dernier caracdtre est
	 }                 // mis  zro.
	 break;
case 13: done=1;           // l'utilisateur a valid en appuyant sur Entre
	 break;            // ainsi done est mis  1
case 27: exit(0);          // Quitte le programme si l'utilisateur a appuyer
			   // Echap
default: if(clavier>30&&i<19){nom[i++]=clavier;} //Si une touche de n > 30
	 break; // et si on n'en est pas au 19 caractre "nom" se dote d'une
}               // lettre en plus

cprintf("\rvotre nom (20 maxi) : %s ",nom); //crit le nom entrer
gotoxy(wherex()-1,wherey()); //replace le curseur une position en arrire
}
if (!(strcmpi(nom, ""))) goto tiptop; // si l'utilisateur n'a rien entrer
				      // il retourne au repre
_setcursortype(_NOCURSOR); // On fait disparatre le curseur
}


// ͻ
//  Intro() - Valide le choix de l'utilisateur lors du premier cran      
// ͼ
void intro()
{
BlackComingOut(50); // L'cran fond vers le noir avec des pauses de 50ms
_AX = 0x13;         // AX est gal au mode dsir, ici: VGA 320*200 256c
geninterrupt(0x10); // On valide avec l'interrution vido 10h
SuperBlack();       // On rend la palette de l'cran noire
Buffer intro;       // On cre un buffer
intro.Load("chap5a.pcx"); //On charge un fichier dedans
intro.Show(0,0,vga);  //et on l'affiche  l'cran sans intermdiaire
if (!ImgComingOut(50,intro.palette)) // On charge lentement la palette de
{                                    // l'image
delay(2000); // on attend 2 secondes => l'utilisateur observe l'image
BlackComingOut(50);  //Fondue vers la couleur noire avec des pauses de 50ms
}

memset(vga,0,64000);  // On nettoie l'cran

SuperBlack();  // On rend la palette noire
fond1.Load("fond.pcx"); //Charge un fichier PCX dans le buffer fond1
fond1.Show(0,0,fond); // Charge fond1 dans fond
		      // Ce qui nous amne  conomiser de la vitesse
		      // puisqu'on ne sera plus oblig de recharger depuis
		      // disque dur l'image du fond  chaque affichage
memcpy(vga,fond,64000); // on copie le fond sur l'cran
ImgComingOut(20,fond1.palette); // Fondue vers la palette de l'image
}
// ͻ
//  affinfos() - Si l'utilisateur appuit sur Credits                      
// ͼ
int affinfos()
{
writeRGB(25,0,0,0);           // les couleurs 25, 223, 229 sont mis  zro
writeRGB(223,0,0,0);          // en ralit l'image chap5b.pcx N'utilise que
writeRGB(229,0,0,0);          // ces trois-l or bien que l'image de fond et
			      // celle-ci est la mme palette, l'image de
			      // fond n'utilise pas ces trois couleur
Buffer about;          // Dclaration d'un buffer pour l'image de "Credits"
about.Load("chap5b.pcx"); // On charge un fichier PCX dans "about"
about.Show(28,58,vga); // on charge l'image  l'cran mais on ne la voit pas
		       // car nous avons mis  0 (noir) les couleurs qu'elle
		       // utilise.

unsigned char red, green, blue;
unsigned char r,g,b;
unsigned temps=15; // on dclare un temps de 15ms

// Pour plus d'explications voir le fichier sprite.h


red=0;     //on entre dans red, green et blue les coordonnes de la couleur
green=90;                                                            // 25
blue=198;

// ATTENTION: ici j'ai donn les valeurs des composantes sur 256 au lieu
// de 64. Il faudra donc diviser par 4 red, green et blue (256/4=64).

for (int i=0;i<64;i++) // on fait varier la couleur 25 jusqu' obtention
{                      // de ces coordonnes d'origine.
delay(temps);
GetRGB(25,r,g,b);
if (r<red/4)r++; else if(r>red/4)r--;
if (g<green/4)g++; else if(g>green/4)g--;
if (b<blue/4)b++; else if(b>blue/4)b--;
writeRGB(25,r,g,b);
}

red=239;             // Pareil mais pour la couleur 223
green=247;
blue=0;

for (i=0;i<64;i++)
{
delay(temps);
GetRGB(223,(unsigned char)r,(unsigned char)g,(unsigned char)b);
if (r<red/4)r++; else if(r>red/4)r--;
if (g<green/4)g++; else if(g>green/4)g--;
if (b<blue/4)b++; else if(b>blue/4)b--;
writeRGB(223,(unsigned char)r,(unsigned char)g,(unsigned char)b);
}

red=255;             // Pareil mais pour la couleur 229
green=0;
blue=0;

for (i=0;i<64;i++)
{
delay(temps);
GetRGB(229,(unsigned char)r,(unsigned char)g,(unsigned char)b);
if (r<red/4)r++; else if(r>red/4)r--;
if (g<green/4)g++; else if(g>green/4)g--;
if (b<blue/4)b++; else if(b>blue/4)b--;
writeRGB(229,(unsigned char)r,(unsigned char)g,(unsigned char)b);
}
delay(2000);                // on attend 2 secondes


for (i=0;i<64;i++)
{
delay(temps);
GetRGB(25,r,g,b);
if(r>0) r--;
if(g>0) g--;           // On fait varier la couleur 25 vers le noir
if(b>0) b--;
writeRGB(25,r,g,b);
GetRGB(223,r,g,b);
if(r>0) r--;
if(g>0) g--;           // On fait varier la couleur 223 vers le noir
if(b>0) b--;
writeRGB(223,r,g,b);
GetRGB(229,r,g,b);
if(r>0) r--;
if(g>0) g--;           // On fait varier la couleur 229 vers le noir
if(b>0) b--;
writeRGB(229,r,g,b);
}

return 0;
}


// ͻ
//  GetChoice() - Indique sur quel bouton l'utilisateur a appuy          
// ͼ
int GetChoice()
{
unsigned x=0,y=0,retour=0;      //Rcupre les positions x et y de la souris
curseur.GetXY(x,y);

if((x>242)&&(x<(242+bouton1.width)))
{ //Si l'utilisateur a cliqu aux coordonnes du bouton
if((y>170)&&(y<(170+bouton1.height))) //"Quitter"
{Quitter();retour = 1;} // retour = 1 donc "done" sera =  1
if((y>140)&&(y<(140+bouton1.height))) //"Credits"
{Credits();retour = 0;} // retour = 0 on lance Credits
if((y>110)&&(y<(110+bouton1.height))) //"Imprimer"
{Imprimer();retour = 0;} // retour = 0 on lance Imprimer()
if((y>80)&&(y<(80+bouton1.height)))//"Aide"
{Aide();retour = 0;} // retour = 0 on lance "Aide"
}
return retour; //retourne "retour"
}

// ͻ
// ͺ
// ͺ
//  ICI COMMENCE LE PROGRAMME ͺ
// ͺ
// ͺ
// ͺ
// ͼ
void main()
{
initscreen(); //Initialise l'cran et demande le nom de l'utilisateur
intro(); // Lance l'"introduction"

curseur.Init("souris.pcx"); //Initialise la souris

bouton1.Load("bouton1.pcx"); // Charge un fichier PCX dans bouton1

unsigned char destination[65]; // Phrase de bienvenue en haut
unsigned char * bonjour = "Bienvenue dans le Chapitre V !!!\nVotre nom: ";
unsigned char * msg = "AIDE:\nAide: Ecrit ce texte.\nImprimer: Imprime un fichier\nCredits: Donne des informations\nQuitter: Quitte ce programme\n\n\nChaque bouton peut etre active en cliquant\ndessus avec la souris ou en appuyant sur\nALT et la premiere lettre du bouton...\n\nCliquez sur Aide de nouveau ou tapez sur \nEntree pour effacer l'aide.";

strcpy(destination, bonjour); // on mixe "bonjour", "nom" et on met tout dans
strcat(destination, nom);     // destination
int clavier=0,done=0;

curseur.SetXY(160,100);

while(!done) // Tant que "done" est  0
{
if(kbhit()){clavier=getch(); //Touche enfonce ? sioui on la lit
switch(clavier){ // On fait le tri gnral
case 0:  switch(getch()){ // Touche spciale
	 case 16: Quitter();  // Alt-Q => "Quitter"
		  done=1;     // done est  1
		  break;
	 case 23: Imprimer();  // Alt-I => "Imprimer"
		  break;
	 case 46: Credits();  // Alt-C => "Credits"
		  break;
	 case 30: Aide(); // Alt-A => "Aide"
		  break;
	 }
	 break;}

if(actif==1) // Si l'activit en cours est "Imprimer"
switch(clavier) //on lit la touche enfonce
{
case 13: if(impression()){ //l'utilisateur a valid le chemin vers le fichier
	 //  imprimer. Si la saisie est mauvaise => Message d'erreur
	 printX("UNE ERREUR S'EST PRODUITE!\nFrappez une touche",30,100,224,vga);
	 getch();} //attend la frappe d'une touche
	 actif=0; // PLus aucune activit en cours
	 break;
case 8:  if(i>0){path[--i]=' ';} // Si on a press Retour Arrire on efface
	 break; // le dernier caractre
default: if(clavier>30&&i<29){path[i++]=clavier;} // Si on frappe une touche
	 break; //de n suprieur  30, "path" a une lettre en plus
}

if(actif==2) if(clavier==13)actif=0; // Si l'activit est "Aide" et que
//l'utilisateur appuy sur Entre plus aucune activit n'est en cours
//et le texte s'effacera au prochain cycle de while

}

if(curseur.GetButton()) done=GetChoice(); // Si un bouton de la souris
// est presse alors on obtient l'action a execute
memset(virtuel,0,64000);  // on nettoie l'cran

memcpy(virtuel,fond,64000);  // on copie le fond dans l'ECRAN VIRTUEL
printX("The World !",248,15,224,virtuel); // On crit The World ! en haut  droite

bouton1.Show(242,80,virtuel); // on affiche un bouton dans l'ECRAN VIRTUEL
printX("Aide",248,83,0,virtuel);// on crit "Aide" dans l'ECRAN VIRTUEL

bouton1.Show(242,110,virtuel);// on affiche un bouton dans l'ECRAN VIRTUEL
printX("Imprimer",248,113,0,virtuel);// on crit "Imprimer" dans l'ECRAN VIRTUEL

bouton1.Show(242,140,virtuel);// on affiche un bouton dans l'ECRAN VIRTUEL
printX("Credits",248,143,0,virtuel);// on crit "Credits" dans l'ECRAN VIRTUEL

bouton1.Show(242,170,virtuel);// on affiche un bouton dans l'ECRAN VIRTUEL
printX("Quitter",257,173,0,virtuel);// on crit "Quitter" dans l'ECRAN VIRTUEL

printX(destination,41,26,252,virtuel); // On crit le message de bienvenue

if(actif==2) //Si l'activit "Aide" est en cours
printX(msg,30,60,255,virtuel); // on affiche le texte d'aide

if(actif==1) //Si l'activit "Imprimer" est en cours
{printX("Entrez le chemin du fichier a imprimer,\npuis validez en appuyant sur Entree:",30,70,255,virtuel);
printX(path,30,86,254,virtuel);} // On crit le chemin vers le fichier

curseur.Show(virtuel); // On affiche le curseur dans l'ECRAN VIRTUEL

memcpy(vga,virtuel,64000); // on copie l'cran virtuel sur l'cran physique
}// fin de la boucle while

delete virtuel; // on libre "virtuel"
delete fond; // ainsi que "fond"

RGBComingOut(30,0,0,10); // On fait un fondu vers un bleu fonc
_AX = 0x0003; // On repasse en mode texte 80*25
geninterrupt(0x10);
_setcursortype(_NORMALCURSOR); // On raffiche le curseur
}



// ͻ
//  Imprimer - Clique du bouton Imprimer et changement du paramtre actif 
// ͼ
void Imprimer()
{
bouton1.Load("bouton2.pcx");  // On charge un fichier dans bouton1
			      // En fait on charge l'image du bouton quand
			      // Il est enfonc
bouton1.Show(242,110,vga);    // On l'affiche sur l'cran physique
printX("Imprimer",248,113,255,vga); // On crit dessus sa fonction
curseur.Show(vga);            // on affiche le curseur
delay(250);                   // on attend 250 ms (esthtique)
while(curseur.GetButton());   // on attend que le bouton de la souris ne
			      // soit plus press
bouton1.Load("bouton1.pcx");  // Ensuite on charge l'image du bouton normal
bouton1.Show(242,110,vga);    // On l'affiche
printX("Imprimer",248,113,0,vga); //On crit dessus sa fonction
curseur.Show(vga);            // On affcihe le curseur
delay(10);                    // on attend 10ms

memset(path,0,30);            // on vide path (on le remplit de 0)
strcpy(path," ");             // on crit un espace dedans sinon printX
i=0;			      // plante car il faut au moins un caractre
if (!actif){actif=1;}         // ensuite si aucune activit n'est en cours
			      // alors actif est mis  1.
}


// ͻ
//  Credits - Clique du bouton Credits et changement du paramtre actif   
// ͼ
void Credits()
{
bouton1.Load("bouton2.pcx");       //  \
bouton1.Show(242,140,vga);         //  |
printX("Credits",248,143,255,vga); //  |
curseur.Show(vga);                 //  |
delay(250);                        //  |
while(curseur.GetButton());        //   > idem que pour imprimer
bouton1.Load("bouton1.pcx");       //  |
bouton1.Show(242,140,vga);         //  |
printX("Credits",248,143,0,vga);   //  |
curseur.Show(vga);                 //  |
delay(10);                         //  /

if (!actif)
affinfos(); // si aucune activit n'est en cours, on lance la
		       // fonction affinfos (The Animation)
}

// ͻ
//  Aide - Clique du bouton Aide et changement du paramtre actif         
// ͼ
void Aide()
{
bouton1.Load("bouton2.pcx");   // \
bouton1.Show(242,80,vga);      // |
printX("Aide",248,83,255,vga); // |
curseur.Show(vga);             // |
delay(250);                    // |
while(curseur.GetButton());    //  > Idem pour Imprimer
bouton1.Load("bouton1.pcx");   // |
bouton1.Show(242,80,vga);      // |
printX("Aide",248,83,0,vga);   // |
curseur.Show(vga);             // |
delay(10);                     // /

if (!actif)actif=2;  // Si aucune activit n'est en cours, l'activit devient
else                 // n2 => Affichage de l'aide
if (actif==2) actif=0; // Sinon, si l'aide est affiche, plus aucune activit
		       // n'est en cours
}


// ͻ
//  Quitter - Clique du bouton Quitter et changement du paramtre actif   
// ͼ
void Quitter()
{
printX("Au Revoir !",246,50,16,vga); // Ecrit un texte en haut  droite

bouton1.Load("bouton2.pcx");       // \
bouton1.Show(242,170,vga);         // |
printX("Quitter",257,173,255,vga); // |
curseur.Show(vga);                 // |
delay(250);                        // |
while(curseur.GetButton());        //  > Idem que pour Imprimer
bouton1.Load("bouton1.pcx");       // |
bouton1.Show(242,170,vga);         // |
printX("Quitter",257,173,0,vga);   // |
curseur.Show(vga);                 // |
delay(10);                         // /
}



// ͻ
//  Impression - Ouvre et imprime le fichier contenu dans "path"          
// ͼ
int impression()
{
if (!(strcmpi(path, ""))) return 123; // si rien n'est entr, on retourne
				      // une valeur autre que 0

   FILE *stream;  // Stream est un handle de type FILE
   char ch; // dclaration d'un caractre ch
   if((stream = fopen(path, "rt")) == NULL) return 123; //on ouvre le fichier
   // en mode "rt" et en cas d'erreur, renvoit une valeur diffrente de 0
   fseek(stream, 0L, SEEK_SET); // se place au dbut du fichier
   do //Boucle...
   {
	switch(ch=fgetc(stream)) //on rcupre un caractre dans stream
	{                        // et on trie
	case '\n': _AH=0x00;           // Fonction impression de caractre
		   _DX=0x00;           // Numro de l'imprimante
		   _AL='\r';           // caractre  imprimer
		   geninterrupt(0x17); // Interruption de l'imprimante
		   _AH=0x00;
		   _DX=0x00;    // Ici si le caractre lu est \n on envoit
		   _AL='\n';    // le caractre \n puis \r car l'imprimante
		   geninterrupt(0x17); // ne convertit pas automatiquement
		   break;

	default :  _AH=0x00; // Dans le cas d'une lettre normale
		   _DX=0x00; // on imprime ch
		   _AL=ch;
		   geninterrupt(0x17);
		   break;
	}
   } while (ch != EOF); // tant qu'on a pas atteint la fin du fichier
   fclose(stream); // On ferme alors le fichier

   _AH=0x00; // Et on envoit le caractre 12, qui signifie quivaut 
   _DX=0x00; // l'ejection de la feuille.
   _AL=0x0C;
   geninterrupt(0x17);

return 0; // si aucun problme on retourne 0.
}