/*
ͻ
                                CHAPITRE V                              
͹
 Ficher: MOUSE.H                                                        
 Description: Gestion de la souris et de son affichage  l'cran        
 Auteur: Franck Bauquier                                                
ͼ
*/

/*
   ͻ
    Pour plus d'informations sur le gestionnaire de la souris, n'hsitez  
    pas  consulter le programme HelpPC tlchargable sur le site Popular 
     l'adresse suivante: http://www.multimania.com/defcon1               
   ͼ
*/

// ͻ
//  Dclaration de la classe MouseType                                    
// ͼ
class MouseType{
public:
unsigned width;          // largeur
unsigned height;         // hauteur
unsigned char * contenu; // Stockage des donnes
int GetButton(); // Obtient si un bouton est press et lequel
void GetXY(unsigned &X, unsigned &Y); // Obtient les coordonnes
void SetXY(unsigned x, unsigned y); // Dfinit ses coordonnes
void Init(unsigned char * fichier); // Iniialisation de la souris
void Show(unsigned char * endroit); // Affichage de la souris
};

// ͻ
//  GetButton - Spcifie quel bouton de la souris est press              
// ͼ
int MouseType::GetButton()
{

_AX=0x03;            // Fonction 03h du gestionnaire de la souris
geninterrupt(0x33);  // interruption 33h
return _BX;          // On retourne la valeur de BX dans laqulle se trouve
		     // le n du bouton press
}

// ͻ
//  GetXY - Spcifie les coordonnes de la souris                         
// ͼ
void MouseType::GetXY(unsigned &X, unsigned &Y)
{
_AX=0x03;
geninterrupt(0x33);
X=_CX; // Retourne CX comme valeur de X
Y=_DX; // et DX pour valeur de Y
}


// ͻ
//  SetXY - dfinit les coordonnes de la souris                          
// ͼ
void MouseType::SetXY(unsigned x, unsigned y)
{
_AX=0x04;
_CX=x;
_DX=y;
geninterrupt(0x33);
}

// ͻ
//  Init - Initialise la souris et charge l'image de curseur dans contenu 
// ͼ
void MouseType::Init(unsigned char * fichier)
{
_AX=0;               // Fonction 0 : Initilisation
geninterrupt(0x33);  // Interruption 33h

unsigned char point;
unsigned avance=0;
int numerateur=0;

FILE * THEFILE;                 // THEFILE : handle de type FILE
THEFILE=fopen(fichier,"rb");    // Ouverture en mode binaire "rb"

unsigned ch1,ch2,tot;
fseek(THEFILE,8L,SEEK_SET);     // On se place  8 octets du dbut
fread(&ch1,2,1,THEFILE);        // On lit 2 octets que l'on place dans ch1
fread(&ch2,2,1,THEFILE);        // On lit 2 octets que l'on place dans ch2
ch1++;                          // On incrmente ch1
ch2++;   			// On incrmente ch2
tot=ch1*ch2;                    // on multiplie l'un par l'autre et on met
				// le rsultat dans tot
height=ch2;                     // La hauteur du curseur est ch2
width=ch1;                      // la largeur du curseur est ch1

contenu = new unsigned char[tot]; // On alloue "contenu" d'une taille de tot

fseek(THEFILE,128L,SEEK_SET);   // On se place  128 du dbut

do// Boucle...
{
  point=fgetc(THEFILE);              // point reoit un octet de THEFILE
	if ((point & 0xC0)==0xC0)    // les deux 1ers bits sont-ils  1 ?
	{                            // OUI
	  numerateur = point & 0x3F; // numrateur est = aux 6 derniers bits
	  point=fgetc(THEFILE);      // On lit le prochain
	  for(int k=1;k<=numerateur;k++) // boucle sur numrateur pendant
	  contenu[avance++]=point; // laquelle contenu reoit le pixel
	}
	else                         // NON
	  contenu[avance++]=point;   // contenu reoit juste le pixel
}while(avance <= tot); // Tant qu'on est pas gal  tot
fclose(THEFILE);                     // ferme THEFILE

unsigned xmax=320-width;             // Calcul de Xmax
unsigned ymax=200-height;            // Calcul de Ymax

_AX=0x04;                            // Place aux coordonnes 160,100
_CX=160;                             // le curseur
_DX=100;
geninterrupt(0x33);

_AX=0x07;                            // Dlimite les extrmits en abscisse
_CX=0;                               // de la souris
_DX=xmax;
geninterrupt(0x33);

_AX=0x08;			    // Dlimite les extrmits en ordonne
_CX=0;                              // de la souris
_DX=ymax;
geninterrupt(0x33);
}

// ͻ
//  Show - Affiche le curseur  un endroit indiqu                        
// ͼ
void MouseType::Show(unsigned char * endroit)
{
unsigned Y,X;                 // Dclaration de deux entiers X et Y
_AX=0x03;
geninterrupt(0x33);
X=_CX;                        // Obtention des coordonnes de la souris
Y=_DX;

for (int u=0;u<=height-1;u++)     // Charge l'image de la souris ("contenu")
for (int z=0;z<=width-1;z++)      // dans l'"endroit" indiqu
{
if((int)contenu[u*width+z]!=0)
endroit[320*(Y+u)+X+z]=(unsigned char)contenu[u*width+z];
}

}


