/*
  ͻ
                                  CHAPITRE V                              
  ͹
   Ficher: SPRITE.H                                                       
   Description: Gestion d'affichage de sprite EN MODE VGA 13h             
   Auteur: Franck Bauquier                                                
  ͼ
*/

// ͻ
//  Dclaration de la classe Buffer                                       
// ͼ
class Buffer{
public:
unsigned height; // Hauteur
unsigned width;  // Largeur
unsigned char palette[256][3]; // Palette du sprite
unsigned char * contenu; // Pointeur sur les donnes du sprites
void Show(unsigned X, unsigned Y, unsigned char * endroit);
void Load(unsigned char * fichier);
~Buffer(); // Fonction destructeur
};

// ͻ
//  ~Buffer - Fonction destructeur: libre la mmoire alloue             
// ͼ
Buffer::~Buffer()
{
delete palette;  // Libre la mmoire alloue par "palette"
delete contenu;  // Libre la mmoire alloue par le pointeur "contenu"
}

// ͻ
//  Load - Initialise et charge un fichier dans le "contenu" du sprite    
// ͼ
void Buffer::Load(unsigned char * fichier)
{
unsigned char point;
unsigned avance=0;
int numerateur=0;

FILE * THEFILE;                 // THEFILE : handle de type FILE
THEFILE=fopen(fichier,"rb");    // Ouverture en mode binaire "rb"

unsigned ch1,ch2,tot;
fseek(THEFILE,8L,SEEK_SET);     // On se place  8 octets du dbut
fread(&ch1,2,1,THEFILE);        // On lit 2 octets que l'on place dans ch1
fread(&ch2,2,1,THEFILE);        // On lit 2 octets que l'on place dans ch2
ch1++;                          // On incrmente ch1
ch2++;   			// On incrmente ch2
tot=ch1*ch2;                    // on multiplie l'un par l'autre et on met
				// le rsultat dans tot
height=ch2;                     // La hauteur du curseur est ch2
width=ch1;                      // la largeur du curseur est ch1

contenu = new unsigned char[tot]; // On alloue "contenu" d'une taille de tot

fseek(THEFILE,-768L,SEEK_END);  // On se place  768 octets de la fin
fread(palette,768,1,THEFILE);   // On charge 768 octets dans palette

fseek(THEFILE,128L,SEEK_SET);   // On se place  128 du dbut

do// Boucle...
{
  point=fgetc(THEFILE);              // point reoit un octet de THEFILE
	if ((point & 0xC0)==0xC0)    // les deux 1ers bits sont-ils  1 ?
	{                            // OUI
	  numerateur = point & 0x3F; // numrateur est = aux 6 derniers bits
	  point=fgetc(THEFILE);      // On lit le prochain
	  for(int k=1;k<=numerateur;k++) // boucle sur numrateur pendant
	  contenu[avance++]=point; // laquelle contenu reoit le pixel
	}
	else                         // NON
	  contenu[avance++]=point;   // contenu reoit juste le pixel
}while(avance <= tot); // Tant qu'on est pas gal  tot
fclose(THEFILE);                     // ferme THEFILE
}


// ͻ
//  Show - Afiche le Sprite aux coordonnes et  l'endroit voulus         
// ͼ
void Buffer::Show(unsigned X, unsigned Y, unsigned char * endroit)
{
for (int u=0;u<=height-1;u++)     // Charge l'image de la souris ("contenu")
for (int z=0;z<=width-1;z++)      // dans l'"endroit" indiqu
{
if((int)contenu[u*width+z]!=0)    // Effet de transparence
endroit[320*(Y+u)+X+z]=(unsigned char)contenu[u*width+z]; // on charge
}
}

